﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IndustryConnect.Bootcamp.One
{
    public class StringHandling
    {
        public static void Example()
        {
            HandleString();

            BuildStringWithFormat();

            BuildStringWithStringBuilder();
        }

        static void HandleString()
        {
            string text1 = "C:\\Application\nis my path"; // "\" needs to be escaped 
            text1.WriteLine();

            // everything is escaped if it starts with @
            string text2 =
@"C:\Application
is my path
";
            text2.WriteLine();
        }

        /// <summary>
        /// Builds the string with format.
        /// </summary>
        static void BuildStringWithFormat()
        {
            // string concate
            string name = null;
            int age = 50;
            bool isHealthy = true;

            // use this to conact the strings, much more readable and safe - null values will show as empty string
            var text3 = string.Format("{0} is {1} and he is healhty:{2}", name, age, isHealthy);
            text3.WriteLine();

            // old way is - hard to read! and will throw error if null values.
            var text4 = name + " is " + age.ToString() + " and he is healthy:" + isHealthy;
            text4.WriteLine();
        }

        /// <summary>
        /// Builds the string with string builder.
        /// </summary>
        static void BuildStringWithStringBuilder()
        {
            // string concate in a routine and for large string. e.g. build html
            var stringBuilder = new StringBuilder();
            stringBuilder.Append("hello,");
            stringBuilder.AppendLine("good day"); // added new line after
            stringBuilder.AppendFormat("{0} is {1}", "c#", "cool");
            stringBuilder.WriteLine();
        }
    }
}
